//+-------------------------------------------------------------------------
//|
//| SudokuMain
//|
//| Defines various example grids, evauates command line arguments and
//| finally calls the solving algorithm to solve the desired sudoku.
//| See the README that should have come with this file on how to compile
//| and run, and on how to solve your own sudokus.
//|
//| (c) 2009, 2020 Dietmar Koenig <http://www.faoileag.de>
//|
//| This program is free software: you can redistribute it and/or modify
//| it under the terms of the GNU General Public License as published by
//| the Free Software Foundation, either version 3 of the License, or
//| (at your option) any later version.
//|
//| This program is distributed in the hope that it will be useful,
//| but WITHOUT ANY WARRANTY; without even the implied warranty of
//| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//| GNU General Public License for more details.
//|
//| You should have received a copy of the GNU General Public License
//| along with this program. If not, see <https://www.gnu.org/licenses/>.
//|
//+-------------------------------------------------------------------------
public class SudokuMain {
  public static void main( String[] args ) {
    SudokuSolver solver = new SudokuSolver( );
    if ( args.length == 0 ) {
      solver.Solve( Grid31( ) );
    }
    else if ( args[0].equals( "11" ) ) {
      solver.Solve( Grid11( ) );
    }
    else if ( args[0].equals( "12" ) ) {
      solver.Solve( Grid12( ) );
    }
    else if ( args[0].equals( "21" ) ) {
      solver.Solve( Grid21( ) );
    }
    else if ( args[0].equals( "22" ) ) {
      solver.Solve( Grid22( ) );
    }
    else if ( args[0].equals( "31" ) ) {
      solver.Solve( Grid31( ) );
    }
    else if ( args[0].equals( "32" ) ) {
      solver.Solve( Grid32( ) );
    }
    else if ( args[0].equals( "41" ) ) {
      solver.Solve( Grid41( ) );
    }
    else if ( args[0].equals( "42" ) ) {
      solver.Solve( Grid42( ) );
    }
    else if ( args[0].equals( "51" ) ) {
      solver.Solve( Grid51( ) );
    }
    else {
      System.out.println ( "Invalid argument: '" + args[0] + "'" );
    }
  }

  public static String Grid51( ) {
    String stringGrid = "";

    stringGrid += "123456789";
    stringGrid += "000000000";
    stringGrid += "000000000";

    stringGrid += "000000000";
    stringGrid += "000000000";
    stringGrid += "000000000";

    stringGrid += "000000000";
    stringGrid += "000000000";
    stringGrid += "234567891";

    return stringGrid;
  }

  public static String Grid42( ) {
    String stringGrid = "";

    stringGrid += "805060024";
    stringGrid += "030001000";
    stringGrid += "700000509";

    stringGrid += "000800007";
    stringGrid += "080000090";
    stringGrid += "600003000";

    stringGrid += "402000006";
    stringGrid += "000400070";
    stringGrid += "950030401";

    return stringGrid;
  }

  public static String Grid41( ) {
    String stringGrid = "";

    stringGrid += "005290807";
    stringGrid += "700540010";
    stringGrid += "000000609";

    stringGrid += "000000700";
    stringGrid += "800000003";
    stringGrid += "002000000";

    stringGrid += "301000000";
    stringGrid += "080063004";
    stringGrid += "904025100";

    return stringGrid;
  }

  public static String Grid32( ) {
    String stringGrid = "";

    stringGrid += "008704600";
    stringGrid += "000000000";
    stringGrid += "507020403";

    stringGrid += "010302040";
    stringGrid += "000080000";
    stringGrid += "080109060";

    stringGrid += "806050102";
    stringGrid += "000000000";
    stringGrid += "002906300";

    return stringGrid;
  }

  public static String Grid31( ) {
    String stringGrid = "";

    stringGrid += "050008312";
    stringGrid += "003000400";
    stringGrid += "670000000";

    stringGrid += "040072008";
    stringGrid += "000000000";
    stringGrid += "100480060";

    stringGrid += "000000029";
    stringGrid += "005000600";
    stringGrid += "927500030";

    return stringGrid;
  }

  public static String Grid22( ) {
    String stringGrid = "";

    stringGrid += "002405600";
    stringGrid += "060703080";
    stringGrid += "500000007";

    stringGrid += "059000730";
    stringGrid += "400108002";
    stringGrid += "013000840";

    stringGrid += "100000003";
    stringGrid += "040307090";
    stringGrid += "008206100";

    return stringGrid;
  }

  public static String Grid21( ) {
    String stringGrid = "";

    stringGrid += "000702000";
    stringGrid += "083000620";
    stringGrid += "102000807";

    stringGrid += "060801030";
    stringGrid += "409000506";
    stringGrid += "030506090";

    stringGrid += "805000403";
    stringGrid += "074000150";
    stringGrid += "000304000";

    return stringGrid;
  }

  public static String Grid12( ) {
    String stringGrid = "";

    stringGrid += "003007040";
    stringGrid += "900800500";
    stringGrid += "015204300";

    stringGrid += "658000030";
    stringGrid += "070309060";
    stringGrid += "040000217";

    stringGrid += "002706480";
    stringGrid += "006008003";
    stringGrid += "080500100";

    return stringGrid;
  }

  public static String Grid11( ) {
    String stringGrid = "";

    stringGrid += "000065030";
    stringGrid += "600108000";
    stringGrid += "005000200";

    stringGrid += "120030090";
    stringGrid += "700609008";
    stringGrid += "080040076";

    stringGrid += "004000900";
    stringGrid += "000702004";
    stringGrid += "060380000";

    return stringGrid;
  }
}

